import { Dispatcher } from 'flux';
import Store, { StoreGetter, StoreResponses, StoreResponse } from './Store';
export declare type StoreFactoryDefinition<T> = {
    getter?: StoreGetter<T>;
    getInitialState?: StoreGetter<T>;
    name?: string;
    responses?: StoreResponses<T>;
};
export default class StoreFactory<T> {
    _definition: StoreFactoryDefinition<T>;
    constructor({ getter, getInitialState, name, responses, }?: StoreFactoryDefinition<T>);
    defineGet(getter: StoreGetter<T>): StoreFactory<T>;
    defineGetInitialState(getInitialState: StoreGetter<T>): StoreFactory<T>;
    defineName(name: string): StoreFactory<T>;
    defineResponses(newResponses: StoreResponses<T>): StoreFactory<T>;
    defineResponseTo(actionTypes: string | Array<string>, response: StoreResponse<T>): StoreFactory<T>;
    getDefinition(): StoreFactoryDefinition<T>;
    register(dispatcher?: Dispatcher<any>): Store<T>;
}
